import re
import json
from AbstractDataObject import AbstractDataObject
from datetime import datetime

class FlatDataObject(AbstractDataObject):
    def __init__(self, serverName, nameSpaceIndex, variableName, dataValue):
        super().__init__(serverName + '/' + str(nameSpaceIndex) + '/' + variableName)
        self.serverName = serverName
        self.nameSpaceIndex = nameSpaceIndex
        self.variableName = variableName
        self.dataValue = dataValue

    def getPayload(self):
        payload = {
            "server": self.serverName,
            "ns": self.nameSpaceIndex,
            "d": self.variableName,
            "value": self.dataValue.Value.Value,
            "status": self.dataValue.StatusCode.name,
            "t1": str(self.dataValue.SourceTimestamp),
            "t2": str(self.dataValue.ServerTimestamp),
            "t3": str(datetime.utcnow())
        }
        return json.dumps(payload)
