import re
import json
from AbstractDataObject import AbstractDataObject
from datetime import datetime

class StructuredDataObject(AbstractDataObject):
    def __init__(self, topicPart):
        super().__init__(topicPart)
        self.keyValuePairs = {}

    def add(self, key, dataValue):
        self.keyValuePairs[key] = {
            "value": dataValue.Value.Value,
            "status": dataValue.StatusCode.name,
            "t1": str(dataValue.SourceTimestamp),
            "t2": str(dataValue.ServerTimestamp),
            "t3": str(datetime.utcnow())
        }


    def getPayload(self):
        return json.dumps(self.keyValuePairs)
